#version 120

/* DRAWBUFFERS:0N2N4 */


uniform sampler2D texture;
uniform float rainStrength;

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;

varying vec3 normal;

varying float iswater;

uniform int worldTime;

float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;


void main() {	

//Changing watercolor if water-texture doesn't work (Mac users)//
vec4 watercolor = vec4(0.1,0.2,1.0,0.6);	//Red//Green//Blue//Opacity//
vec4 tex = texture2D(texture, texcoord.xy);


 if (iswater > 0.9) tex = watercolor;

 
//TP Water-texture over the water//	
vec3 indlmap = mix(lmcoord.t,1.0,lmcoord.s)*texture2D(texture,texcoord.xy).rgb*color.rgb;
gl_FragData[0] = vec4(indlmap,texture2D(texture,texcoord.xy).a*color.a);
gl_FragDepth = gl_FragCoord.z;
	
	vec4 frag2;
	

			frag2 = vec4((normal) * 0.5f + 0.5f, 1.0f);			
	
	
	gl_FragData[2] = frag2;	
	gl_FragData[4] = vec4(0.0, mix(1.0,0.05,iswater), lmcoord.s, 1.0);
	
}